<?php

function get_duplicated_templates() {
    return array('HomeTemplate' => true, 'BlogTemplate' => true, 'SinglePostTemplate' => true, 'PageTemplate' => true, 'ForumTemplate' => true, 'CustomTemplate' => true, 'DefaultTemplate' => true, 'Template404' => true);
}

function get_templates_dir($theme_dir) {
    return $theme_dir . '/templates';
}

function remove_theme_page_file($file_info, $theme_dir, &$changed_files) {
    $templates_dir = get_templates_dir($theme_dir);
    $name = $file_info['filename'];
    $suffix = strpos($name, '--') !== false ? '--' : '-';
    $files = array($templates_dir . '/html/html' . $suffix . $name .'.tpl.php', $templates_dir . '/page/page' . $suffix.$name .'.tpl.php');
    foreach ($files as $file) {
        if (is_file($file)) {
            FilesHelper::delete_file($file);
            $changed_files[] = $file; // remove Drupal template files from both base and preview themes
        }
    }
}

function build_theme_page_file($content, $file_info, $theme_dir, &$changed_files) {
    $to_save = array();
    $templates_dir = get_templates_dir($theme_dir);
    $name = $file_info['filename'];
    $suffix = '--';
    $page = $content;
    if (strpos($name, $suffix) !== false) { // 7.x
        $html_content = "\n<?php print \$page_top; ?>\n<?php print \$page; ?>\n<?php print \$page_bottom; ?>\n";
        $pattern = '/(.*?<body.*?\?>>)(.*?)(<\/body.*?html>)/si';
        $page = preg_replace($pattern, '$2', $content);
        $html = preg_replace($pattern, '$1'.$html_content.'$3', $content);
        $to_save[] = array('path' => $templates_dir . '/html/html' . $suffix . $name .'.tpl.php', 'content' => $html);
    } else {
        $suffix = '-'; // 6.x
    }
    $to_save[] = array('path' => $templates_dir . '/page/page' . $suffix . $name .'.tpl.php', 'content' => $page);
    if (strpos($name, 'default') !== false) { // always save the whole content to maintenance page as last default template
        $to_save[] = array('path' => $templates_dir . '/page/maintenance-page.tpl.php', 'content' => $content);
    }

    foreach ($to_save as $save) {
        save_to_change($save['path'], $save['content'], $changed_files);
    }
    
    drupal_flush_all_caches();
}